"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentHighlighter = void 0;
const react_1 = __importStar(require("react"));
const modules_dom_to_react_1 = require("@teambit/modules.dom-to-react");
const ui_hover_selector_1 = require("@teambit/ui.hover-selector");
const frame_1 = require("../frame");
const label_1 = require("../label");
const bit_react_component_1 = require("./bit-react-component");
function ComponentHighlighter(_a) {
    var { children, disabled } = _a, rest = __rest(_a, ["children", "disabled"]);
    const [text, setText] = react_1.useState(undefined);
    const [target, setTarget] = react_1.useState(null);
    const handleElement = react_1.useCallback((element) => {
        if (!element) {
            setTarget(null);
            setText(undefined);
            return;
        }
        const bitComponent = bubbleToBitComponent(element, (elem) => !elem.hasAttribute('data-ignore-component-highlight'));
        if (!bitComponent)
            return;
        setText(bitComponent.id);
        setTarget(bitComponent.element);
    }, []);
    react_1.useEffect(() => {
        if (disabled) {
            setTarget(null);
            setText(undefined);
        }
    }, [disabled]);
    return (react_1.default.createElement(ui_hover_selector_1.HoverSelector, Object.assign({}, rest, { onElementChange: handleElement, disabled: disabled, style: { fontFamily: 'sans-serif' }, "data-ignore-component-highlight": true }),
        children,
        react_1.default.createElement(frame_1.Frame, { targetRef: target, "data-ignore-component-highlight": true }),
        text && (react_1.default.createElement(label_1.LabelContainer, { targetRef: target, offset: [0, 8], placement: "top", "data-ignore-component-highlight": true },
            react_1.default.createElement(label_1.Label, { componentId: text, "data-ignore-component-highlight": true })))));
}
exports.ComponentHighlighter = ComponentHighlighter;
function bubbleToBitComponent(element, filter) {
    for (let current = element; current; current = current.parentElement) {
        current = modules_dom_to_react_1.toRootElement(current);
        if (!current || (filter === null || filter === void 0 ? void 0 : filter(current)) === false)
            return undefined;
        const component = modules_dom_to_react_1.domToReact(current);
        if (bit_react_component_1.isBitComponent(component))
            return {
                element: current,
                component,
                id: component.__bitComponentId || 'unknown',
            };
    }
    return undefined;
}
//# sourceMappingURL=component-highlighter.js.map